Attribute VB_Name = "modCheckUnicodeSupport"
'***************************************************************
' (c) Copyright 2000 Matthew J. Curland
'
' This file is from the CD-ROM accompanying the book:
' Advanced Visual Basic 6: Power Techniques for Everyday Programs
'   Author: Matthew Curland
'   Published by: Addison-Wesley, July 2000
'   ISBN: 0-201-70712-8
'   http://www.PowerVB.com
'
' You are entitled to license free distribution of any application
'   that uses this file if you own a copy of the book, or if you
'   have obtained the file from a source approved by the author. You
'   may redistribute this file only with express written permission
'   of the author.
'
' This file depends on:
'   References:
'     None
'   Files:
'     None
'   Minimal VBoost conditionals:
'     None
'   Conditional Compilation Values:
'     None
'***************************************************************
Option Explicit
Private Declare Function GetWindowsDirectoryW Lib "kernel32" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private m_fInit As Boolean
Private m_fIsUnicode As Boolean
Public Property Get UnicodeSystem() As Boolean
    If Not m_fInit Then
        m_fIsUnicode = GetWindowsDirectoryW(vbNullString, 0)
        m_fInit = True
    End If
    UnicodeSystem = m_fIsUnicode
End Property
