Attribute VB_Name = "modMinimalEditWL"
'***************************************************************
' (c) Copyright 2000 Matthew J. Curland
'
' This file is from the CD-ROM accompanying the book:
' Advanced Visual Basic 6: Power Techniques for Everyday Programs
'   Author: Matthew Curland
'   Published by: Addison-Wesley, July 2000
'   ISBN: 0-201-70712-8
'   http://www.PowerVB.com
'***************************************************************
Option Private Module
Option Explicit

Private Type TwoWords
    LOWORD As Integer
    HIWORD As Integer
End Type
Private Type OneDWord
    DWord As Long
End Type

Public Function LOWORD(ByVal InVal As Long) As Integer
Dim dw As OneDWord
Dim tw As TwoWords
    dw.DWord = InVal
    LSet tw = dw
    LOWORD = tw.LOWORD
End Function

Public Function HIWORD(ByVal InVal As Long) As Integer
Dim dw As OneDWord
Dim tw As TwoWords
    dw.DWord = InVal
    LSet tw = dw
    HIWORD = tw.HIWORD
End Function

Public Function RedirectEditProc(ByVal This As MinimalEditWL, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    RedirectEditProc = This.WindowProc(hWnd, uMsg, wParam, lParam)
End Function

Public Function RedirectEditProcParent(ByVal This As MinimalEditWL, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    RedirectEditProcParent = This.WindowProcParent(hWnd, uMsg, wParam, lParam)
End Function
